// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: config/middleware/accesslog/v1/accesslog.proto

package accesslogv1

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
)

// Validate checks the field values on Config with the rules defined in the
// proto definition for this message. If any rules are violated, an error is returned.
func (m *Config) Validate() error {
	if m == nil {
		return nil
	}

	for idx, item := range m.GetStatusCodeFilters() {
		_, _ = idx, item

		if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return ConfigValidationError{
					field:  fmt.Sprintf("StatusCodeFilters[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	return nil
}

// ConfigValidationError is the validation error returned by Config.Validate if
// the designated constraints aren't met.
type ConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ConfigValidationError) ErrorName() string { return "ConfigValidationError" }

// Error satisfies the builtin error interface
func (e ConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ConfigValidationError{}

// Validate checks the field values on Config_StatusCodeFilter with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *Config_StatusCodeFilter) Validate() error {
	if m == nil {
		return nil
	}

	switch m.FilterType.(type) {

	case *Config_StatusCodeFilter_Equals:

		if val := m.GetEquals(); val < 0 || val > 16 {
			return Config_StatusCodeFilterValidationError{
				field:  "Equals",
				reason: "value must be inside range [0, 16]",
			}
		}

	}

	return nil
}

// Config_StatusCodeFilterValidationError is the validation error returned by
// Config_StatusCodeFilter.Validate if the designated constraints aren't met.
type Config_StatusCodeFilterValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e Config_StatusCodeFilterValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e Config_StatusCodeFilterValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e Config_StatusCodeFilterValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e Config_StatusCodeFilterValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e Config_StatusCodeFilterValidationError) ErrorName() string {
	return "Config_StatusCodeFilterValidationError"
}

// Error satisfies the builtin error interface
func (e Config_StatusCodeFilterValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConfig_StatusCodeFilter.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = Config_StatusCodeFilterValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = Config_StatusCodeFilterValidationError{}
