// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: config/module/chaos/experimentation/xds/v1/xds.proto

package xdsv1

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
)

// Validate checks the field values on Config with the rules defined in the
// proto definition for this message. If any rules are violated, an error is returned.
func (m *Config) Validate() error {
	if m == nil {
		return nil
	}

	if m.GetCacheRefreshInterval() == nil {
		return ConfigValidationError{
			field:  "CacheRefreshInterval",
			reason: "value is required",
		}
	}

	if d := m.GetCacheRefreshInterval(); d != nil {
		dur, err := d.AsDuration(), d.CheckValid()
		if err != nil {
			return ConfigValidationError{
				field:  "CacheRefreshInterval",
				reason: "value is not a valid duration",
				cause:  err,
			}
		}

		gt := time.Duration(0*time.Second + 0*time.Nanosecond)

		if dur <= gt {
			return ConfigValidationError{
				field:  "CacheRefreshInterval",
				reason: "value must be greater than 0s",
			}
		}

	}

	if len(m.GetRtdsLayerName()) < 1 {
		return ConfigValidationError{
			field:  "RtdsLayerName",
			reason: "value length must be at least 1 bytes",
		}
	}

	if m.GetResourceTtl() == nil {
		return ConfigValidationError{
			field:  "ResourceTtl",
			reason: "value is required",
		}
	}

	if d := m.GetResourceTtl(); d != nil {
		dur, err := d.AsDuration(), d.CheckValid()
		if err != nil {
			return ConfigValidationError{
				field:  "ResourceTtl",
				reason: "value is not a valid duration",
				cause:  err,
			}
		}

		gt := time.Duration(0*time.Second + 0*time.Nanosecond)

		if dur <= gt {
			return ConfigValidationError{
				field:  "ResourceTtl",
				reason: "value must be greater than 0s",
			}
		}

	}

	if m.GetHeartbeatInterval() == nil {
		return ConfigValidationError{
			field:  "HeartbeatInterval",
			reason: "value is required",
		}
	}

	if d := m.GetHeartbeatInterval(); d != nil {
		dur, err := d.AsDuration(), d.CheckValid()
		if err != nil {
			return ConfigValidationError{
				field:  "HeartbeatInterval",
				reason: "value is not a valid duration",
				cause:  err,
			}
		}

		gt := time.Duration(0*time.Second + 0*time.Nanosecond)

		if dur <= gt {
			return ConfigValidationError{
				field:  "HeartbeatInterval",
				reason: "value must be greater than 0s",
			}
		}

	}

	if v, ok := interface{}(m.GetEcdsAllowList()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ConfigValidationError{
				field:  "EcdsAllowList",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	return nil
}

// ConfigValidationError is the validation error returned by Config.Validate if
// the designated constraints aren't met.
type ConfigValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ConfigValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ConfigValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ConfigValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ConfigValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ConfigValidationError) ErrorName() string { return "ConfigValidationError" }

// Error satisfies the builtin error interface
func (e ConfigValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConfig.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ConfigValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ConfigValidationError{}

// Validate checks the field values on Config_ECDSAllowList with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *Config_ECDSAllowList) Validate() error {
	if m == nil {
		return nil
	}

	if len(m.GetEnabledClusters()) < 1 {
		return Config_ECDSAllowListValidationError{
			field:  "EnabledClusters",
			reason: "value must contain at least 1 item(s)",
		}
	}

	return nil
}

// Config_ECDSAllowListValidationError is the validation error returned by
// Config_ECDSAllowList.Validate if the designated constraints aren't met.
type Config_ECDSAllowListValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e Config_ECDSAllowListValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e Config_ECDSAllowListValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e Config_ECDSAllowListValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e Config_ECDSAllowListValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e Config_ECDSAllowListValidationError) ErrorName() string {
	return "Config_ECDSAllowListValidationError"
}

// Error satisfies the builtin error interface
func (e Config_ECDSAllowListValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sConfig_ECDSAllowList.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = Config_ECDSAllowListValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = Config_ECDSAllowListValidationError{}
